unit Unit1; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  StdCtrls, ComCtrls, Grids, Buttons, Crt, (*Beachte KeyPreview im Formular*)
  Process;

type

  { TFormsimpleGUIgrep }

  TFormsimpleGUIgrep = class(TForm)
    BitBtnStart: TBitBtn;
    ButtonDialogPfadsuche: TButton;
    ButtonAbbruch: TButton;
    ButtonHomeDokumente: TButton;
    ButtonHome: TButton;
    CheckBoxMitDateiname: TCheckBox;
    CheckBoxRegulaererAusdruck: TCheckBox;
    CheckBoxAdministrator: TCheckBox;
    CheckBoxSchreibung: TCheckBox;
    CheckBoxMitUnterverzeichnissen: TCheckBox;
    EditSuchtext: TEdit;
    EditSuchpfad: TEdit;
    EditBefehl: TEdit;
    LabelSuchtext: TLabel;
    LabelSuchpfad: TLabel;
    LabelBefehlGREP: TLabel;
    MemoAnleitung: TMemo;
    PanelComputer: TPanel;
    Process: TProcess;
    SelectDirectoryDialog: TSelectDirectoryDialog;
    StatusBar: TStatusBar;
    procedure BitBtnStartClick(Sender: TObject);
    procedure ButtonAbbruchClick(Sender: TObject);
    procedure ButtonHomeClick(Sender: TObject);
    procedure ButtonHomeDokumenteClick(Sender: TObject);
    procedure ButtonDialogPfadsucheClick(Sender: TObject);
    procedure CheckBoxAdministratorChange(Sender: TObject);
    procedure CheckBoxMitDateinameChange(Sender: TObject);
    procedure CheckBoxMitUnterverzeichnissenChange(Sender: TObject);
    procedure CheckBoxRegulaererAusdruckChange(Sender: TObject);
    procedure CheckBoxSchreibungChange(Sender: TObject);
    procedure EditSuchpfadChange(Sender: TObject);
    procedure EditSuchtextChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);

    procedure Befehl(Sender: TObject);

  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  FormsimpleGUIgrep: TFormsimpleGUIgrep;

  ParameterR, ParameterI, ParameterH, ParameterE, Admin:  string;
  TextDatei:                                              TextFile;
  TextZeile:                                              string;

const
  Apostroph=#39;

implementation

{$R *.lfm}

{ TFormsimpleGUIgrep }

(*--------------------------- StartBedingungen -------------------------------*)

procedure TFormsimpleGUIgrep.FormCreate(Sender: TObject);

begin
  ParameterR        := '-r ';
  ParameterI        := '-i ';
  ParameterH        := '-H ';
  ParameterE        := '-E ' ;
  Admin             := '';
  EditSuchtext.Text := '...';
  EditSuchpfad.Text := GetUserDir+'Dokumente/';
  EditBefehl.Text   := 'grep '+ParameterR+ParameterI+ParameterH+ParameterE+
                       '"'+EditSuchtext.Text+'"'+' '+EditSuchPfad.Text;
  ButtonAbbruch.Enabled:=false;
  AssignFile(TextDatei,'/tmp/simpleGUIgrep.sh');                                // /tmp
  Try                                                                           // Anlegen Skript für Rechte einstellen
    Rewrite(TextDatei);                                                         // hier günstig, da Rechte bei Rewrite erhalten bleiben!
    Except
      ShowMessage('Skript simpleGUIgrep.sh kann nicht anlegen werden! Bitte Verzeichnisse und Rechte prüfen!');
      Halt;
  end;

  TextZeile:='#!/bin/bash';
  WriteLN(Textdatei,TextZeile);
  CloseFile(TextDatei);

  Process.CommandLine:='chmod 777 /tmp/simpleGUIgrep.sh';                       // Recht einstellen /tmp
  Process.Active:=true;                                                         // eigentlicher Aufruf

  StatusBar.Panels[0].Text:='Programm simpleGUIgrep gestartet. Die Voreinstellungen sind optimal!';
end;

(*--------------------------- Befehl -----------------------------------------*)

procedure TFormsimpleGUIgrep.Befehl(Sender: TObject);

var i: integer;

Begin
  If (ParameterE='-E ') and (Length(EditSuchtext.Text)>1) then
    Begin
      TextZeile:=EditSuchtext.Text[1]+'\';
      for i:=2 to Length(EditSuchtext.Text) do
        TextZeile:=TextZeile+'W*'+EditSuchtext.Text[i]+'\';
      TextZeile:=TextZeile+'W';
    End                                                   else
    TextZeile:=EditSuchtext.Text;

  EditBefehl.Text:=Admin+'grep '+ParameterR+ParameterI+ParameterH+ParameterE+
                   '"'+TextZeile+'"'+' '+EditSuchPfad.Text;
end;

(*--------------------------- mit Unterverzeichnisse -------------------------*)

procedure TFormsimpleGUIgrep.CheckBoxMitUnterverzeichnissenChange(Sender: TObject);
begin
  If CheckBoxMitUnterverzeichnissen.Checked=True then ParameterR:='-r '
                                                 else ParameterR:='';
  Befehl(Sender);

  StatusBar.Panels[0].Text:='Einstellung für Lesen Unterverzeichnisse geändert.';
end;

(*--------------------------- Groß- Klein- Schreibung ------------------------*)

procedure TFormsimpleGUIgrep.CheckBoxSchreibungChange(Sender: TObject);
begin
  If CheckBoxSchreibung.Checked=True then ParameterI:='-i '
                                     else ParameterI:='';
  Befehl(Sender);

  StatusBar.Panels[0].Text:='Einstellung für Unterschied Groß- und Kleinschreibung geändert.';
end;

(*--------------------------- Anzeige Dateiname ------------------------------*)

procedure TFormsimpleGUIgrep.CheckBoxMitDateinameChange(Sender: TObject);
begin
  If CheckBoxMitDateiname.Checked=True then ParameterH:='-H '
                                       else ParameterH:='-h ';
  Befehl(Sender);

  StatusBar.Panels[0].Text:='Einstellung für Ausgabe Dateiname geändert.';
end;

(*--------------------------- regulärer Ausdruck -----------------------------*)

procedure TFormsimpleGUIgrep.CheckBoxRegulaererAusdruckChange(Sender: TObject);
begin
  If CheckBoxRegulaererAusdruck.Checked=True then ParameterE:='-E '
                                             else ParameterE:='';
  Befehl(Sender);

  StatusBar.Panels[0].Text:='Einstellung für regulärer Ausdruck geändert. (Beachte auch Suchtext im Befehl!)';
end;

(*--------------------------- Suche mit administrativen Rechten --------------*)

procedure TFormsimpleGUIgrep.CheckBoxAdministratorChange(Sender: TObject);
begin
  If CheckBoxAdministrator.Checked=True then Admin:='sudo '
                                        else Admin:='';
    Befehl(Sender);

    StatusBar.Panels[0].Text:='Einstellung für Suche mit administrativen Rechten geändert.';
end;

(*--------------------------- Suchtext ---------------------------------------*)

procedure TFormsimpleGUIgrep.EditSuchtextChange(Sender: TObject);
begin
  Befehl(Sender);

  StatusBar.Panels[0].Text:='Suchtext geändert.';
end;

(*--------------------------- Suchpfad ---------------------------------------*)

procedure TFormsimpleGUIgrep.EditSuchpfadChange(Sender: TObject);
begin
  Befehl(Sender);

  StatusBar.Panels[0].Text:='Suchpfad geändert. Präziser Suchpfad verkürzt Suchzeit! Achte auf Groß- und Kleinschreibung!';
end;

(*--------------------------- Suchpfad /home/user/Dokumente ------------------*)

procedure TFormsimpleGUIgrep.ButtonHomeDokumenteClick(Sender: TObject);
begin
  EditSuchpfad.Text:=GetUserDir+'Dokumente/';

  Befehl(Sender);

  StatusBar.Panels[0].Text:='Suchpfad /home/user/Dokumente eingestellt. Präziser Suchpfad verkürzt Suchzeit!';
end;

(*--------------------------- Suchpfad /home/user ----------------------------*)

procedure TFormsimpleGUIgrep.ButtonHomeClick(Sender: TObject);
begin
  EditSuchpfad.Text:=GetUserDir;

  Befehl(Sender);

  StatusBar.Panels[0].Text:='Suchpfad /home/user eingestellt. Beachte längere Laufzeit!';
end;

(*--------------------------- Suche Pfad mit Dialog --------------------------*)

procedure TFormsimpleGUIgrep.ButtonDialogPfadsucheClick(Sender: TObject);
begin
  if SelectDirectoryDialog.Execute then
    begin
      EditSuchpfad.Text:=SelectDirectoryDialog.FileName;
      EditSuchpfad.Text:=''''+EditSuchpfad.Text+'''';

      Befehl(Sender);

      StatusBar.Panels[0].Text:='Suchpfad mit Dialog eingestellt. Beachte längere Laufzeit!';
    end;
end;

(*--------------------------- Suche ------------------------------------------*)

procedure TFormsimpleGUIgrep.BitBtnStartClick(Sender: TObject);
begin
  If (EditSuchpfad.Text='') or (EditSuchtext.Text='') or
     (EditBefehl.Text='') Then
  MessageDlg('Fehler: Eingaben unvollständig!',mtInformation,[mbOK],0)
                          Else
  Begin
    Try                                                                         // Anlegen Skript
      Rewrite(TextDatei);
      Except
        ShowMessage('Skript simpleGUIgrep.sh kann nicht anlegen werden! Bitte Verzeichnisse und Rechte prüfen!');
        Halt;
    end;

    TextZeile:='#!/bin/bash';
    WriteLN(TextDatei,TextZeile);
    TextZeile:='# 03.10.2014 - Freiheit   ><>';
    WriteLN(Textdatei,TextZeile);
    TextZeile:='echo Start Skript simpleGUIgrep.sh - Bitte haben Sie etwas Geduld!';
    WriteLN(Textdatei,TextZeile);
    TextZeile:='echo Befehl: '+EditBefehl.Text;
//    ShowMessage('Befehl: '+EditBefehl.Text);
    WriteLN(Textdatei,TextZeile);
    TextZeile:='echo';
    WriteLN(Textdatei,TextZeile);

    TextZeile:=EditBefehl.Text;
    WriteLN(Textdatei,TextZeile);

    TextZeile:='echo';
    WriteLN(Textdatei,TextZeile);
    TextZeile:='echo Ende Skript simpleGUIgrep.sh - Danke für die Benutzung!';
    WriteLN(Textdatei,TextZeile);

    CloseFile(TextDatei);
    ButtonAbbruch.Enabled := true;
//    ShowMessage('Haltepunkt nach Rewrite einstellen');
    Process.CommandLine:='xterm -hold -sb -right -geometry 180x50 -e /tmp/./simpleGUIgrep.sh';
    Process.Active:=true;                                                       // eigentlicher Aufruf

    StatusBar.Panels[0].Text:='Suche gestartet. Gedrückte Maustaste im Terminal-Fenster hält Suche an! Click auf x im Terminal-Fenster beendet Suche!   ><>';
  end;
end;

(*--------------------------- Abbruch ----------------------------------------*)

procedure TFormsimpleGUIgrep.ButtonAbbruchClick(Sender: TObject);
begin
  Process.Active:=false;
  ButtonAbbruch.Enabled:=false;
  StatusBar.Panels[0].Text:='Ende / Abbruch angefordert.';
end;

end.

